#ifndef CUDA_HELPERS_H
#define CUDA_HELPERS_H

#include "opengl.h"
#include "defines.h"

extern "C" 
{
	void CUDA_Init(int dev);
	void CUDA_RegisterVBO(GLuint vbo);
	void CUDA_UnregisterVBO(GLuint vbo);
	void CUDA_CheckError(const char *msg);

	void CUDA_AllocateArray(void **devPtr, size_t size);
	void CUDA_FreeArray(void *devPtr);
	void CUDA_ThreadSync();
}

#endif

