#ifndef TYPES_H
#define TYPES_H

#include <cuda_runtime_api.h>

//#include "LBM_config.h"

struct vertex
{
	vertex( float x, float y, float z) 
	{
		x_pos = x;
		y_pos = y;
		z_pos = z;
	}

	vertex() {}

	float x_pos;
	float y_pos;
	float z_pos;

	float flux;
};		


struct line 
{
	float4 p0, p1;
};

static float t_3d[19]  __attribute__ ((unused))= 
{ 
	1.f/3.f,  // 0
	1.f/18.f, // 1
	1.f/18.f, // 2
	1.f/18.f, // 3
	1.f/36.f, // 4
	1.f/36.f, // 5
	1.f/36.f, // 6
	1.f/36.f, // 7
	1.f/36.f, // 8
	1.f/36.f, // 9			
	1.f/18.f, // 10
	1.f/18.f, // 11
	1.f/18.f, // 12         
	1.f/36.f, // 13
	1.f/36.f, // 14
	1.f/36.f, // 15   
	1.f/36.f, // 16
	1.f/36.f, // 17
	1.f/36.f  // 18
};

static float c_3d[19][3] __attribute__ ((unused)) = 
{
	{0, 0, 0},    // 0
	{-1, 0, 0},   // 1
	{0, -1, 0},   // 2
	{0, 0, -1},   // 3
	{-1, -1, 0},  // 4
	{-1, 1, 0},   // 5
	{-1, 0, -1},  // 6 
	{-1, 0, 1},   // 7 
	{0, -1, -1},  // 8
	{0, -1, 1},   // 9
	{1, 0, 0},    // 10
	{0, 1, 0},    // 11
	{0, 0, 1},    // 12
	{1, 1, 0},    // 13
	{1, -1, 0},   // 14
	{1, 0, 1},    // 15
	{1, 0, -1},   // 16
	{0, 1, 1},    // 17
	{0, 1, -1}    // 18
};

static double t_3d_double[19]  __attribute__ ((unused))= 
{ 
	1./3.,  // 0
	1./18., // 1
	1./18., // 2
	1./18., // 3
	1./36., // 4
	1./36., // 5
	1./36., // 6
	1./36., // 7
	1./36., // 8
	1./36., // 9      
	1./18., // 10
	1./18., // 11
	1./18., // 12         
	1./36., // 13
	1./36., // 14
	1./36., // 15   
	1./36., // 16
	1./36., // 17
	1./36.  // 18
};

static int c_3d_double[19][3]  __attribute__ ((unused))= 
{
	{0, 0, 0},    // 0
	{-1, 0, 0},   // 1
	{0, -1, 0},   // 2
	{0, 0, -1},   // 3
	{-1, -1, 0},  // 4
	{-1, 1, 0},   // 5
	{-1, 0, -1},  // 6 
	{-1, 0, 1},   // 7 
	{0, -1, -1},  // 8
	{0, -1, 1},   // 9
	{1, 0, 0},    // 10
	{0, 1, 0},    // 11
	{0, 0, 1},    // 12
	{1, 1, 0},    // 13
	{1, -1, 0},   // 14
	{1, 0, 1},    // 15
	{1, 0, -1},   // 16
	{0, 1, 1},    // 17
	{0, 1, -1}    // 18
};

#endif
