#include <fstream>
#include <cstdio>
#include "Road.h"

using namespace std;
using namespace clothoid;

Road::Road(string road_def_file, double scale, double min_elev) : trajectory(0)
{
    vector<Vec2d> ctrlpoints;

    //Read the road definition file
    ifstream f(road_def_file.c_str());

    //Read mesh filename
    string s;
    getline(f, s);

    while (!f.eof() && !f.fail())
    {
        Vec2d v;
        f >> v.x >> v.y;
        v *= scale;
        ctrlpoints.push_back(v);
    }

    trajectory = new ClothoidSpline(ctrlpoints);

    mesh.loadObj(s, scale, true, -min_elev);
}

Road::~Road()
{
    if (trajectory)
        delete trajectory;
}

Mesh& Road::getMesh()
{
    return mesh;
}
