#ifndef WINDSYSTEM_CUH
#define WINDSYSTEM_CUH

#include "defines.h"
#include "vmath.h"
#include "opengl.h"
#include <cstdlib>

#define I(X,Y,Z) (dim.x*dim.z*(Y) + dim.x*(Z) + (X))
#define J(x,z) (tdim*(z)+(x))

enum {
        VOX_SELF = 1<<0,
        VOX_LEFT = 1<<1,
        VOX_RIGHT = 1<<2,
        VOX_UP = 1<<3,
        VOX_DOWN = 1<<4,
        VOX_ABOVE = 1<<5,
        VOX_BELOW = 1<<6,
};


/*static float calc_omega() {
        float rotOmega = float(rand() / ((double) RAND_MAX) * (M_PI / 3 - M_PI / 4) + M_PI / 4);
        if (rand() < RAND_MAX / 2) rotOmega *= -1;
        return rotOmega;
};*/

extern "C" {

        void CUDA_WindField_Init(int xdim, int ydim, int zdim, unsigned int mapdim);
        void CUDA_WindField_Free();

        void CUDA_WindField_Simulate(float deltaTime, bool step, int frame, int point_count, bool isRendering);
        void CUDA_WindField_UpdateObstacles(unsigned int ovbo, int stage, int y);

        void CUDA_WindField_RenderDebug(float limit, GLuint &point_vbo, int point_count);
        void CUDA_WindField_RenderObstacles(GLuint &point_vbo, int point_count);
        void CUDA_WindField_RenderPressure(GLuint &point_vbo, int point_count);

} // extern "C"

#endif

