#ifndef WINDSYSTEM_LBM_CUH
#define WINDSYSTEM_LBM_CUH

// Extra debug
#include "defines.h"
#include "vmath.h"
#include "opengl.h"
#include <cstdlib>

// The lattice Boltzmann method
//#include "LBM_config.h"
#include "LBM_types.h"

void CUDA_WindField_RenderDebug_LBM(float limit, GLuint &point_vbo, int point_count);
void CUDA_WindField_RenderObstacles_LBM(GLuint &point_vbo, int point_count);
void CUDA_WindField_RenderPressure_LBM(GLuint &point_vbo, int point_count);
void CUDA_WindField_Init_LBM(int xdim, int ydim, int zdim, unsigned int mapdim, float_type initVel, float_type initRho);
void CUDA_Simulate_WindField_LBM(int collideKernelType, float_type omega, float deltaTime, bool step, int frame, int extra, int boundarySize, float3 boundaryFactor, float_type boundaryRho, float_type force, bool isRendering, float& mlups);
void wind_to_texture_lbm(cudaPitchedPtr src);
void CUDA_WindField_Free_LBM();
void allocateMemoryGPU(int size_x, int size_y, int size_z, int boundary_size, float4 velFactor, float_type *f0_h, float_type *f1_h, float_type *f2_h, float_type *f3_h, float_type *f4_h, float_type *f5_h, float_type *f6_h, float_type *f7_h, float_type *f8_h, float_type *f9_h, float_type *f10_h, float_type *f11_h, float_type *f12_h, float_type *f13_h, float_type *f14_h, float_type *f15_h, float_type *f16_h, float_type *f17_h, float_type *f18_h);
void createVelocityField(cudaPitchedPtr vel_field, double &time, const int dimX, const int dimY, const int dimZ);
void applyOuterBoundariesGPU(int extra, double &time, int boundarySize, float3 boundaryFactor, float_type boundaryRho);
int countNumFluidNodes();
void streamAndSwapGPU(int extra, double &time);
void collideAndSwapGPU(float_type omega, float_type force, int extra, double &time, int kernel_type);

#endif
