#include "config.h"
#include "conf.h"
#include <cstdlib>
#include <cstring>
#include <cmath> 
#include <cstdio>

Config conf;

void load_config(const char *filename) {
#if 0
    conf.screenWidth = 640;
    conf.screenHeight = 480;
    conf.fullscreen = true;
#else
//    conf.screenWidth = 1900;
//    conf.screenHeight = 686;
    conf.screenWidth = 1600;
    conf.screenHeight = 1024;
    //conf.fullscreen = false;
    conf.fullscreen = true;
#endif
    //rotation of camera
    conf.rotateX = 256;
    //conf.rotateX = 0;
    conf.rotateY = 120;
    conf.rotateZ = 155;
    conf.rotateHeight = 150;
    conf.rotateRadius = 150;

    conf.eyeSeparation = 0.25;
    conf.stereo = false;
    conf.movementSpeed = 32.0f*2.0f;
    conf.mouseSensitivityX = 0.001f;
    conf.mouseSensitivityY = 0.001f;
    conf.clearColor = 0x54487100;    // background color

    conf.windX = 62;
    conf.windY = 30;
    conf.windZ = 62;

    conf.numParticles = 0.25*PART_BLOCK*4096;//PART_BLOCK*512;

    // Mt. st. Helens (before eruption)
    conf.map.height = conf.map.width = 256;
    conf.map.heightmap = "helens256b.raw";
    conf.map.minHeight = 873;
    conf.map.maxHeight = 2951;
    conf.map.resX = conf.map.resY = 30;
    conf.roadDefinitionFile = "helens256b.rd";
/*
    // Mt. st. Helens (after eruption)
    conf.map.height = conf.map.width = 768;
    conf.map.heightmap = "helens768.raw";
    conf.map.normalmap = "helens768_normal.raw";
    conf.map.minHeight = 900;
    conf.map.maxHeight = 2550;
    conf.map.resX = conf.map.resY = 10;
    conf.roadDefinitionFile = "helens768.rd";
    /////////////////////////////////
*/
    // Trondheim
//    conf.map.height = conf.map.width = 5021;
//    conf.map.heightmap = "trondheim_5020.raw";
//    conf.map.normalmap = "trondheim_5020_normal.raw";
//    conf.map.minHeight = -5;
//    conf.map.maxHeight = 1036;
//    conf.map.resX = conf.map.resY = 20;

//    Mountain terrain
/*    conf.map.height = conf.map.width = 1024;
    conf.map.heightmap = "mntterrain1024.raw";
    conf.map.normalmap = "mntnormal1024.raw";
    conf.map.minHeight = 0;
    conf.map.maxHeight = 2700;
    conf.map.resX = conf.map.resY = 10;
    conf.roadDefinitionFile = "mntroad.rd";
*/
    //Random terrain
//    conf.map.height = conf.map.width = 1025;
//    conf.map.heightmap = "height1024.raw";
//    conf.map.normalmap = "normal1024.raw";
//    conf.map.minHeight = 0;
//    conf.map.maxHeight = 2700;
//    conf.map.resX = conf.map.resY = 20;
 
    //Random terrain (smaller)
//    conf.map.height = conf.map.width = 513;
//    conf.map.heightmap = "height512.raw";
//    conf.map.normalmap = "normal512.raw";
//    conf.map.minHeight = 0;
//    conf.map.maxHeight = 1000;
//    conf.map.resX = conf.map.resY = 20;

    //Random terrain (even smaller)
//    conf.map.height = conf.map.width = 257;
//    conf.map.heightmap = "height256.raw";
//    conf.map.normalmap = "normal256.raw";
//    conf.map.minHeight = 0;
//    conf.map.maxHeight = 600;
//    conf.map.resX = conf.map.resY = 20;



    conf.usingLBM = false;
    // 0 - Regular
    // 1 - Shared
    // 2 - Precice
    // 3 - Double (remember to set typedef in defines.h!)
    conf.LBMCollideKernel = 2;
    conf.LBMInitVel = 0.01;
    conf.LBMInitRho = 1.0;
    conf.LBMOmega = 1.f / 0.63;
    //    conf.LBMOmega = 1.f / 0.50;
    conf.LBMViscosity = (1./6. * (2./conf.LBMOmega - 1.));
    // Multiplied by the macroscopic velocity calculated in each node
    // Increase to increase the wind's effect on the snow
    conf.LBMVelFactor.x = ((float)conf.map.width / (float)conf.windX) * 20.0;
    conf.LBMVelFactor.y = ((float)conf.map.height / (float)conf.windX) * 20.0;
    conf.LBMVelFactor.z = ((float)conf.map.width /  (float)conf.windX) * 20.0;
    // Multiplied by the boundary velocity (in lattice units)
    // Decrease the values if some of the boundary velocities makes the simulation unstable
    conf.LBMBoundaryVelFactor.x = 
        conf.LBMBoundaryVelFactor.y = 
        conf.LBMBoundaryVelFactor.z = 0.1;
    conf.LBMBoundaryVelFactor.w = 1.0;


    //conf.LBMVelFactor.x = 40;
    //conf.LBMVelFactor.y = 40;
    //conf.LBMVelFactor.z = 40;

    // Overhead view
    conf.camX = 200.0f;
    conf.camY = 100.0f;
    conf.camZ = 100.0f;
    conf.camYaw = 0.0f;
    conf.camPitch = -(float)M_PI*0.1f;

    // Birds-eye view
    /*conf.camX = -50.0f;
      conf.camY = 192.0f;
      conf.camZ = -50.0f;
      conf.camYaw = (float)0.25*M_PI;
      conf.camPitch = -(float)0.25*M_PI;*/

    // True if the alternate particle initialization is to be used
    // This is the same as the demo version of the code (tends to distribute more evenly)
    conf.useAlternateParticleInit = false;

    conf.simulateWind = true;
    conf.simulateSnow = true;
    conf.renderSnow = true;
//    conf.simulateSnow = true;
//    conf.renderSnow = true;

        // Quit when a number of seconds have elapsed
	conf.timeLimit = 0;
        // Quit when a number of frames is reached (for performance testing)
        // Evaluated after timeLimit
        //conf.frameLimit = 199;
	conf.frameLimit = 0;
	
	conf.device = 0;
    conf.enableDisplay = true;

    // Quit when a number of seconds have elapsed
    conf.timeLimit = 0;
    // Quit when a number of frames is reached (for performance testing)
    // Evaluated after timeLimit
    //conf.frameLimit = 199;
    conf.frameLimit = 0;//1003;


    //Make snow growth dependent on map dimensions. Otherwise, larger maps will fill with snow slower.
    conf.snowGrowth = 4.*0.004 * (conf.map.width*conf.map.height)/(512.*512.);
    conf.gravity = 9.981f;

    Conf *cfg = Conf::load(filename);

    while(cfg) {
        if(!strcmp(cfg->name(), "screenWidth")) conf.screenWidth = atoi(cfg->value());
        if(!strcmp(cfg->name(), "screenHeight")) conf.screenHeight = atoi(cfg->value());
        if(!strcmp(cfg->name(), "fullscreen")) conf.fullscreen = atoi(cfg->value());

        if(!strcmp(cfg->name(), "usingLBM")) conf.usingLBM = atoi(cfg->value());

        if(!strcmp(cfg->name(), "camX")) conf.camX = atof(cfg->value());
        if(!strcmp(cfg->name(), "camY")) conf.camY = atof(cfg->value());
        if(!strcmp(cfg->name(), "camZ")) conf.camZ = atof(cfg->value());
        if(!strcmp(cfg->name(), "camYaw")) conf.camYaw = atof(cfg->value());
        if(!strcmp(cfg->name(), "camPitch")) conf.camPitch = atof(cfg->value());

        if(!strcmp(cfg->name(), "windX")) conf.windX = atoi(cfg->value());
        if(!strcmp(cfg->name(), "windY")) conf.windY = atoi(cfg->value());
        if(!strcmp(cfg->name(), "windZ")) conf.windZ = atoi(cfg->value());
        if(!strcmp(cfg->name(), "numParticles")) conf.numParticles = atoi(cfg->value());

        if(!strcmp(cfg->name(), "simulateWind")) conf.simulateWind = atoi(cfg->value());
        if(!strcmp(cfg->name(), "simulateSnow")) conf.simulateSnow = atoi(cfg->value());
        if(!strcmp(cfg->name(), "renderSnow")) conf.renderSnow = atoi(cfg->value());

        if(!strcmp(cfg->name(), "mapDim")) conf.map.width = conf.map.height = atoi(cfg->value());
        if(!strcmp(cfg->name(), "heightmap")) conf.map.heightmap = cfg->value();
        if(!strcmp(cfg->name(), "normalmap")) conf.map.normalmap = cfg->value();
        if(!strcmp(cfg->name(), "minHeight")) conf.map.minHeight = atof(cfg->value());
        if(!strcmp(cfg->name(), "maxHeight")) conf.map.maxHeight = atof(cfg->value());

        if(!strcmp(cfg->name(), "timeLimit")) conf.timeLimit = atoi(cfg->value());
        if(!strcmp(cfg->name(), "frameLimit")) conf.frameLimit = atoi(cfg->value());

        if(!strcmp(cfg->name(), "device")) conf.device = atoi(cfg->value());

        if(!strcmp(cfg->name(), "snowGrowth")) conf.snowGrowth = atof(cfg->value());
        if(!strcmp(cfg->name(), "gravity")) conf.gravity = atof(cfg->value());

        if(!strcmp(cfg->name(), "enableDisplay")) conf.enableDisplay = atoi(cfg->value());

        cfg = cfg->next();
    }

    if(cfg)
        Conf::free(cfg);

    if(conf.numParticles % PART_BLOCK)
        conf.numParticles -= conf.numParticles % PART_BLOCK;
}
