#ifndef CONFIG_H
#define CONFIG_H

#include "defines.h"
#include <string>

struct Map { 
    int width, height;
    std::string heightmap, normalmap;
    float minHeight, maxHeight;
    float resX, resY;
};

struct Config {
    int screenWidth, screenHeight;
    bool fullscreen;
    float eyeSeparation;
    bool stereo;
    float movementSpeed;
    float mouseSensitivityX;
    float mouseSensitivityY;
    int numParticles;
    bool useAlternateParticleInit;
    unsigned int clearColor;

    bool rotate;
    float rotateX, rotateZ, rotateY, rotateHeight, rotateRadius;

    float camX, camY, camZ;
    float camYaw, camPitch;

    int windX, windY, windZ;

    bool simulateWind;
    bool simulateSnow;
    bool renderSnow;

    bool enableDisplay;

    Map map;
    std::string roadDefinitionFile;
//    std::string normalmap, heightmap;
//    int mapDim;

    int timeLimit;
    int frameLimit;

    int device;

    float snowGrowth;
    float gravity;

    bool usingLBM;
    int LBMCollideKernel;
    float_type LBMInitVel;
    float_type LBMInitRho;
    float_type LBMOmega;
    float_type LBMViscosity;
    float4 LBMVelFactor;
    float4 LBMBoundaryVelFactor;
};

extern Config conf;

void load_config(const char *filename);

#endif
