#include "opengl.h"
#include <cstdarg>
#include <cstdio>

bool glCheckError(const char *fmt, ...) {
	GLenum code;
	if((code = glGetError()) != GL_NO_ERROR) {
		va_list ap;

		printf("OpenGL error: %s\n\t", gluErrorString(code));

		va_start(ap, fmt);
		vprintf(fmt, ap);
		va_end(ap);

		printf("\n");
		return true;
	}
	return false;
}

void glEnable2D() {
        int viewport[4];
        glGetIntegerv(GL_VIEWPORT, viewport);

        glMatrixMode(GL_PROJECTION);
        glPushMatrix();
        glLoadIdentity();
        glOrtho(0, viewport[2], 0, viewport[3], -1, 1);

        glMatrixMode(GL_MODELVIEW);
        glPushMatrix();
        glLoadIdentity();
}

void glDisable2D() {
        glMatrixMode(GL_PROJECTION);
        glPopMatrix();
        glMatrixMode(GL_MODELVIEW);
        glPopMatrix();
}
