#ifndef GLPRIMITIVE_H
#define GLPRIMITIVE_H

#include "opengl.h"
#include "shaderprogram.h"
#include "glm/glm.hpp"
struct Vertex
{
  glm::vec3 p, n, t;
};


class Primitive {
  public:
      ~Primitive();

      virtual void tesselate(glm::vec3 tess, glm::vec3 translate, glm::vec3 scale) = 0; //tesselates and reuploads into vbo
      void draw();
      void draw(ShaderProgram *program);
      void draw(ShaderProgram *program, int instances);
    
      GLuint vertexID() { return vertexId_; }
      GLuint indexID() { return indexId_; }
      
      const glm::vec3& scale() { return scale_; }
      const glm::vec3& translate() { return scale_; }
  protected:
      Primitive(glm::vec3 &tess, glm::vec3 &translate, glm::vec3 &scale);

      GLuint vertexId_, indexId_;
      GLenum type_;
      GLuint idxCount_;
      GLuint typeCount_;
      int vOffset_, tOffset_, nOffset_;

      glm::vec3 scale_, translate_;
};

class Quad : public Primitive {
    public:
	Quad(glm::vec3 tess, glm::vec3 translate, glm::vec3 scale);
	~Quad();

	void tesselate(glm::vec3 tess, glm::vec3 translate, glm::vec3 scale);
};

class Rect : public Primitive {
public:
    Rect(glm::vec3 tess, glm::vec3 translate, glm::vec3 scale);
    ~Rect();

    void tesselate(glm::vec3 tess, glm::vec3 translate, glm::vec3 scale);
};

class Plane : public Primitive {
    public:
	Plane(glm::vec3 tess, glm::vec3 translate, glm::vec3 scale);
	~Plane();

	void tesselate(glm::vec3 tess, glm::vec3 translate, glm::vec3 scale);
};

class Icosohedron : public Primitive {
    public:
	Icosohedron(glm::vec3 tess, glm::vec3 translate, glm::vec3 scale);
	~Icosohedron();

	void tesselate(glm::vec3 tess, glm::vec3 translate, glm::vec3 scale);
};

#endif // GLPRIMITIVE_H
