#ifndef SHADER_H
#define SHADER_H

#include <GL/glew.h>
#include <GL/glfw.h>

class Shader {
public:
	
	bool load(const char *vertname, const char *fragname);
	
	void bind();
	void unbind();
	
	void uniform(const char *name, int a);
	void uniform(const char *name, int a, int b);
	void uniform(const char *name, int a, int b, int c);
	void uniform(const char *name, int a, int b, int c, int d);
	
	void uniform(const char *name, float a);
	void uniform(const char *name, float a, float b);
	void uniform(const char *name, float a, float b, float c);
	void uniform(const char *name, float a, float b, float c, float d);

	void attribute(const char *name, float *v);
	void attribute(const char *name, GLuint comps, GLenum type, void *v);
	
private:
	
	GLhandleARB program, vertex, fragment;
};

#endif
