
uniform mat4 modelviewMatrix2;
uniform mat4 projMatrix2;

#ifdef _VERTEX_
uniform vec3 eye;
uniform int type;


varying float alpha;
varying float dist;

void main() {
    vec3 pos = gl_Vertex.xyz;
    float theta = gl_Vertex.w;
    
    dist = length(pos - eye);
    alpha = 1.0;
    
    //alpha = theta / 6.28;
    
    if(type == 0) {
        gl_PointSize = max(2.0, min(8.0, 100.0/dist));
        //alpha = 1.0;
        //alpha = max(0.3, 1.0 - dist/200.0);

	//alpha = 0.7;
    }
    else {
        gl_PointSize = min(32.0, dist/64.0);
        alpha = max(0.01, 1.0 - dist/1800.0);
    }
    
	gl_Position = projMatrix2 * modelviewMatrix2 * vec4(pos, 1.0);
    gl_TexCoord[0] = gl_MultiTexCoord0;
}
#endif

#ifdef _FRAGMENT_
uniform sampler2D colormap;
//uniform vec4 color;

varying float alpha;
varying float dist;

void main() {
    //gl_FragColor = color;
    //gl_FragColor = vec4(0.4, 0.4, 0.8, 1.0);
    vec4 c;
    //if(dist < 300.0)
        c = texture2D(colormap, gl_TexCoord[0].st);
    //else
    //    c = vec4(1.0, 1.0, 1.0, 1.0);
    c.a *= alpha;
    gl_FragColor = c;
}
#endif
