#version 400
uniform mat4 modelviewMatrix2;
uniform mat4 projMatrix2;

#ifdef _VERTEX_
uniform vec3 eye;
uniform int type;


layout(location = 0) in vec4 vPos;

out float alpha;
out float dist;

void main() {
    vec3 pos = vPos.xyz;
        
    dist = length(pos - eye);
    alpha = 1.0;

    
    if(type == 0) {
        gl_PointSize = max(2.0, min(8.0, 100.0/dist));
    }
    else {
        gl_PointSize = min(32.0, dist/64.0);
        alpha = max(0.01, 1.0 - dist/1800.0);
    }
    
	gl_Position = projMatrix2 * modelviewMatrix2 * vec4(pos, 1.0);
}
#endif

#ifdef _FRAGMENT_
uniform sampler2D colormap;

in float alpha;
in float dist;

layout ( location = 0 ) out vec4 FragColor;
void main() {
    FragColor = texture2D(colormap, gl_PointCoord);
    FragColor.a *= alpha;
}
#endif
